//
// Created by elouan on 26/11/2021.
//
#include <stdio.h>
#include <string.h>
#include <math.h>

char b64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

int indexInBase(char c);

int main(int argc, char **argv){
    char *str = st; // à encoder
    //str est la chaine pour l'encodage, changer le code si besoin

    int len = strlen(str);

    if(strcmp(argv[1], "-e") == 0) {
        char conc[len * 9];
        char binary[9] = "00000000";
        strcpy(conc, "");

        for (int indexl = 0; indexl < len; indexl++) {
            strcpy(binary, "00000000");
            int n = str[indexl];
            for (int i = 7; n > 0; i--) {
                binary[i] = n % 2 + '0';
                n = n / 2;
            }

            strcat(conc, binary);
        }

        int oindex = 0;
        char encode[len * 8];
        int sum = 0;
        int encodeindex = 0;
        for (int i = 0; i < 8 * len; i++) {
            if (oindex % 6 == 0 && oindex > 0) {
                oindex = 0;
                encode[encodeindex] = b64[sum];
                sum = 0;
                encodeindex++;
            }
            if (conc[i] == '1') {
                sum += pow(2, 5 - oindex);
            }

            oindex++;
        }
        encode[encodeindex] = b64[sum];
        printf("%s", encode);
        int equal = oindex;
        if (equal % 2 != 0)equal -= 1;
        if (equal == 2)printf("==");
        else if (equal == 4)printf("=");
	printf("\n");
    }
    else if (strcmp(argv[1], "-d") == 0){
        char *str = "UGgnbmx1aSBtbHcnbmFmaCBDdGh1bGh1IFInbHllaCB3YWgnbmFsIGZodGFuCg=="; //chaine à tester pour decode
        int hex[1024];
        int equalBit    ;
        char binary[8] = "00000000";
        char conc[len * 6];
        strcpy(conc, "");
        int len = strlen(str);

        for(int i = 0; i < strlen(str); i++){
            if(str[i] == '='){
                if (str[i-1] == '='){
                    equalBit = 2;
                }
                else{
                    equalBit = 1;
                }
            }
            else{
                hex[i] = indexInBase(str[i]);
            }
        }
        for (int indexl = 0; indexl < len - equalBit; indexl++) {
            strcpy(binary, "000000");
            int n = hex[indexl];
            for (int i = 5; n > 0; i--) {
                binary[i] = n % 2 + '0';
                n = n / 2;
            }
            strcat(conc, binary);
        }
        int oindex = 0;
        char decode[len * 6];
        int sum = 0;
        int decodeindex = 0;
        for (int i = 0; i < 6 * len; i++) {
            if (oindex % 8 == 0 && oindex > 0) {
                oindex = 0;
                decode[decodeindex] = sum;
                sum = 0;
                decodeindex++;
            }
            if (conc[i] == '1') {
                sum += pow(2, 7 - oindex);
            }

            oindex++;
        }
        for(int i = 0; i < decodeindex - 1; i++){
            printf("%c", decode[i]);
        }

    } else{
        printf("Pas d'arguments -e ou -d");
        return 0;
    }
}

int indexInBase(char c){
    for(int i = 0; i < strlen(b64); i++){
        if(c == b64[i])return i;
    }
    return -1;
}
